
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>C++学习笔记49:栈 / 憋错料</title>

    <meta name="description" content="C++学习笔记49:栈 栈是一种只能从一端访问的线性数据结构,栈是一种后进先出的数据结构 //stack.h #ifndef STACK_H #define STACK_H #include &lt;cassert&gt; template &lt;class T, int SIZE = 50&gt; class Stack { private: T list[SIZE]; int top; public: Stack(); void push(const T &amp;item); T pop(); void cle ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">C++学习笔记49:栈</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>栈是一种只能从一端访问的线性数据结构，栈是一种后进先出的数据结构</p>
<pre>//stack.h
#ifndef STACK_H
#define STACK_H
#include &lt;cassert&gt;
template &lt;class T, int SIZE = 50&gt; class Stack
{
private:
    T list[SIZE];
    int top;
public:
    Stack();
    void push(const T &amp;item);
    T pop();
    void clear();
    const T &amp;peek() const;
    bool isEmpty() const;
    bool isFull() const;
};

//模板的实现
template &lt;class T, int SIZE&gt;
Stack&lt;T, SIZE&gt;::Stack():top(-1){}

template &lt;class T, int SIZE&gt; void Stack&lt;T, SIZE&gt;::push(const T &amp;item)
{
    assert(!isFull());
    list[++top] = item;
}

template &lt;class T, int SIZE&gt; T Stack&lt;T, SIZE&gt;::pop() const
{
    assert(!isEmpty());
    return list[top--];
}

template &lt;class T, int SIZE&gt; const T &amp;Stack&lt;T, SIZE&gt;::peek() const
{
    assert(!isEmpty());
    return list[top];
}

template &lt;class T, int SIZE&gt; bool Stack&lt;T, SIZE&gt;::isEmpty() const
{
    return top == -1;
}

template &lt;class T, int SIZE&gt; bool Stack&lt;T, SIZE&gt;::isFull() const
{
    return top == SIZE - 1;
}

template &lt;class T, int SIZE&gt; void Stack&lt;T, SIZE&gt;::clear()
{
    top = -1;
}

#endif // </pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-16 09:18:39 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/logs/" title="logs">logs</a>, <a href="https://www.biecuoliao.com/tag/void/" title="void">void</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>, <a href="https://www.biecuoliao.com/tag/bsp/" title="bsp">bsp</a>, <a href="https://www.biecuoliao.com/tag/end/" title="end">end</a>, <a href="https://www.biecuoliao.com/tag/ack/" title="ack">ack</a>, <a href="https://www.biecuoliao.com/tag/%e5%ad%a6%e4%b9%a0%e7%ac%94%e8%ae%b0/" title="学习笔记">学习笔记</a>, <a href="https://www.biecuoliao.com/tag/c-%e5%ad%a6%e4%b9%a0/" title="c&plus;&plus;学习">c&plus;&plus;学习</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>C++学习笔记49:栈的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xe5pD3.html" rel="bookmark">数据结构学习笔记之栈</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				栈(stack)  是限定仅在表尾进行插入或删除操作的线性表.因此,对栈来说,表尾端有其特殊含义,称为栈项(top),相应地,表头端称为栈底(bottom).不含元素的空表称为空栈. 栈有两种存储表示方法:顺序栈和链栈.顺序栈,即栈的顺序存储结构是利用一组地址连续的存储单元依次存放自栈底到栈顶的数据元素,同时附设指针top指示栈顶元素在顺序栈中的位置.通常的习惯做法是以top=0表示空栈,鉴于C语言中数组的下标约定从0开始,则当以C作描述语言时,如此设定会带来很大不便:另一方面,由于栈在使用过程			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXdng8M.html" rel="bookmark">学习笔记&colon;&colon;单调栈</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				单调栈和单调队列长得不是很像. 单调栈的用处是求以一个元素为中心,向两边最多拓展多远距离. 两个小时就没了... poj2796 #include&lt;cstdio&gt; using namespace std; typedef long long ll; #define N 200010 struct data { ll v,sum,l,r; }x[N],st[N],ans; ll n; inline void read(ll&amp;a) { ll x=0,f=1; char c=getchar(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0j1b2DM.html" rel="bookmark">Scala中隐式转换初体验实战详解以及隐式转换在Spark中的应用源码解析之Scala学习笔记-49</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				package com.leegh.implicits import scala.io.Sourceimport java.io.File /** * @author Guohui Li */ class RichFile(val file: File) { def read = Source.fromFile(file.getPath()).mkString}object Context { implicit def file2RichFile(file: File) = new RichFi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDDdpeM.html" rel="bookmark">JVM学习笔记-操作数栈&lpar;Operand Stack&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Like the local variables, the operand stack is organized as an array of words. But unlike the local variables, which are accessed via array indices, the operand stack is accessed by pushing and popping values. If an instruction pushes a value onto th			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0adOLEM.html" rel="bookmark">Java学习笔记49（DBUtils工具类二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上一篇文章是我们自己模拟的DBUtils工具类,其实有开发好的工具类 这里使用commons-dbutils-1.6.jar 事务的简单介绍: 在数据库中应用事务处理案例:转账案例 张三和李四都有有自己的存款 主键 帐户名 余额 1 张三 1000 2 李四 10 要从张三的账户余额中转账800到李四账户 SQL语句实现: update xx set 余额 = 余额-800 where 主键=1 update xx set 余额 = 余额+800 where 主键=2 虽然操作成功,但是会出现问			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41z6XJM.html" rel="bookmark">&lbrack;原创&rsqb;java WEB学习笔记59：Struts2学习之路---OGNL&comma;值栈，读取对象栈中的对象的属性，读取 Context Map 里的对象的属性，调用字段和方法，数组，list，map</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本博客的目的:①总结自己的学习过程,相当于学习笔记 ②将自己的经验分享给大家,相互学习,互相交流,不可商用 内容难免出现问题,欢迎指正,交流,探讨,可以留言,也可以通过以下方式联系. 本人互联网技术爱好者,互联网技术发烧友 微博:伊直都在0221 QQ:951226918 -----------------------------------------------------------------------------------------------------------------			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qGaB7M.html" rel="bookmark">&lbrack;原创&rsqb;java WEB学习笔记6：Struts2 学习之路--Struts的CRUD操作&lpar; 查看 &sol; 删除&sol; 添加&rpar; 使用 paramsPrepareParamsStack 重构代码 ，PrepareInterceptor拦截器，paramsPrepareParamsStack 拦截器栈</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本博客的目的:①总结自己的学习过程,相当于学习笔记 ②将自己的经验分享给大家,相互学习,互相交流,不可商用 内容难免出现问题,欢迎指正,交流,探讨,可以留言,也可以通过以下方式联系. 本人互联网技术爱好者,互联网技术发烧友 微博:伊直都在0221 QQ:951226918 -----------------------------------------------------------------------------------------------------------------			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02yb2BM.html" rel="bookmark">java之jvm学习笔记六-十二&lpar;实践写自己的安全管理器&rpar;&lpar;jar包的代码认证和签名&rpar; &lpar;实践对jar包的代码签名&rpar; &lpar;策略文件&rpar;&lpar;策略和保护域&rpar;  &lpar;访问控制器&rpar; &lpar;访问控制器的栈校验机制&rpar; &lpar;jvm基本结构&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				java之jvm学习笔记六(实践写自己的安全管理器) 安全管理器SecurityManager里设计的内容实在是非常的庞大,它的核心方法就是checkPerssiom这个方法里又调用 AccessController的checkPerssiom方法,访问控制器AccessController的栈检查机制又遍历整个 PerssiomCollection来判断具体拥有什么权限一旦发现栈中一个权限不允许的时候抛出异常否则简单的返回,这个过程实际上比我的描述要复杂 得多,这里我只是简单的一句带过,因为这			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YmYjW0.html" rel="bookmark">《数据结构与算法分析》学习笔记（四）&mdash;&mdash;栈ADT</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.栈ADT是what? 1.定义 栈,是限制插入和删除都只能在一个位置上进行的表. 2.图示 3.栈的基本功能 (1)是否为空 (2)进栈 (3)出栈 (4)清空 (5)取栈顶 二.栈的链表实现 &lt;数据结构与算法分析&gt;学习笔记(四)--栈ADT			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/BMz2wyM.html" rel="bookmark" class="title">OC与JS的交互详解</a>
					<div>
						事情的起因还是因为项目需求驱动.折腾了两天,由于之前没有UIWebView与JS交互的经历,并且觉得这次在功能上有一定的创造性,特此留下一点文字,方便日后回顾. 我要实现这样一个需求:按照本地的CSS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0knyxPM.html" rel="bookmark" class="title">php 计算代码行数</a>
					<div>
						&lt;?php header(&quot;Content-type:text/html;charset=utf-8&quot;); // 计算行数 function codeLine($file){ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPNPOa3.html" rel="bookmark" class="title">昂达v981平板刷机教程连接</a>
					<div>
						http://tieba.baidu.com/p/3721193574 http://www.ondabbs.cn/forum.php?mod=viewthread&amp;tid=65393 htt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41g9YX0.html" rel="bookmark" class="title">将数字n转换为字符串并保存到s中</a>
					<div>
						参考 C程序设计语言 #include &lt;stdio.h&gt; #include &lt;string.h&gt; //reverse函数: 倒置字符串s中各字符的位置 void revers ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoGVExM.html" rel="bookmark" class="title">png、jpg、gif三种图片格式的区别</a>
					<div>
						一.首先我们来介绍下矢量图和位图 矢量图和位图,一般情况下我们都使用位图: 矢量图的优点在于文件相对较小,并且放大缩小不会失真.缺点则是这些完美的几何图形很难表现自然度高的写实图像. 位图的优点是利于 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NaZKB3.html" rel="bookmark" class="title">WordPress官方推荐的代码高亮插件</a>
					<div>
						今天花了大半天的时间,终于选择好自己心仪的wordpress代码高亮插件,同时它也是wordpress官方推荐的代码语法高亮插件.在选择的过程中,我对比和试用了若干个代码高亮wordpress插件,包 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mom2ab3.html" rel="bookmark" class="title">HDU3123：GCC（同余模简单题）</a>
					<div>
						题目:http://acm.hdu.edu.cn/showproblem.php?pid=3123 题意很简单,就是同余模的简单应用. 代码如下: #include &lt;iostream&gt;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Y7qVX4.html" rel="bookmark" class="title">iOS7&lowbar;关于UISwitch&lowbar;01&lowbar;如何添加一个UISwitch到界面上</a>
					<div>
						1.首先我们先创建一个 SingleView application. 2.我们可以用Inface Builder 来实现,也可以通过手码来实现.我们这次先通过手码来实现: 首先,我们在 xxxVie ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDvbjw3.html" rel="bookmark" class="title">Spring MVC常用的注解</a>
					<div>
						1.@Controller 在SpringMVC 中,控制器Controller 负责处理由DispatcherServlet 分发的请求,它把用户请求的数据经过业务处理层处理之后封装成一个Model ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3v5RyL0.html" rel="bookmark" class="title">linux服务器硬件报错，系统异常重启检测-MCElog</a>
					<div>
						mcelog 是 x86 的 Linux 系统上用来检查硬件错误,特别是内存和CPU错误的工具.比如服务器隔一段时间莫名的重启一次,而message和syslog又检测不到有价值的信息. 通常发生MC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wWzOV3.html" rel="bookmark" class="title">cocos2d-x多分辨率适配方案：setDesignResolutionSize使用</a>
					<div>
						1. setDesignResolutionSize使用方法及主要的三种适配模式 在cocos2d-x 2.0里,提供了一个叫做setDesignResolutionSize的方法,直接一次设置就可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kpEwp3.html" rel="bookmark" class="title">linux html 文件 web 端显示乱码</a>
					<div>
						在Apache htdoc 里用vi写了个html  但web 端显示乱码了 然后在html 里添加了一段 &lt;head&gt;         &lt;meta http-equiv=&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QjdPQM.html" rel="bookmark" class="title">惠普渠道回归</a>
					<div>
						2014财年,惠普企业集团业务获得了&quot;意外&quot;的快速增长.如何才能将这种&quot;意外&quot;增长变成持续.稳定的增长呢?惠普企业集团已经胸有成竹--强化风险管理,拓展行业和区 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mm92RPM.html" rel="bookmark" class="title">Dreamweaver 添加 cakephp ctp后缀名</a>
					<div>
						Dreamweaver 默认是不支持ctp文件高亮的,即使用Dreamweaver打开ctp文件,也只能像记事本一样编辑 但是我们可以通过修改两个文件,来添加Dreamweaver对ctp文件的扩展支 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AEbEg4.html" rel="bookmark" class="title">hdu 6025 前缀 后缀 gcd</a>
					<div>
						大致题意: 去掉一个元素能使这个数列的GCD最大为多少 分析: 我们求一个数列的GCD,是先求前两个元素的GCD,然后将这个GCD值在与下一个元素进行GCD运算.由此可知进行GCD运算的顺序对最终的结 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLRBkB3.html" rel="bookmark" class="title">魅族手机（魅蓝note）无法作为调试设备连接到mac问题的解决</a>
					<div>
						问题描述: OS X(Yosemite),ADB(1.0.32),Android Studio(1.0.1),魅蓝note手机(m1 note,Android 4.4.4,Flyme OS 4.2.0 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rP1oaM.html" rel="bookmark" class="title">使用Linux模拟FC存储阵列&lpar;targetcli&rpar;</a>
					<div>
						1.环境硬件信息 作为target端的机器  (PC机) HBA卡 : QLogic WWN1 : 21:00:00:1b:32:81:6e:f1 系统 : Ubuntu 15.04 Server 作 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xAGoQ3.html" rel="bookmark" class="title">IGNOREDELETES&comma;IGNOREUPDATES</a>
					<div>
						有时候,我们在ogg目标端应用数据的时候不想应用更新或者删除操作,这时候我们就可以使用IGNOREDELETES, IGNOREUPDATES参数 GETDELETES | IGNOREDELETES ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02rDZD0.html" rel="bookmark" class="title">linux系统网络配置基础（一）</a>
					<div>
						1.虚拟网卡实现一个网卡多个地址2.多网卡bond,mode13.路由实验 一.作业:1.某公司申请到一个C 类IP 地址,但要连接6 个的子公司,最大的一个子 公司有26 台计算机,每个子公司在一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35pNoX0.html" rel="bookmark" class="title">第二会</a>
					<div>
						1.你的团队目标(WBS) 我们的团队目标是服务广大铁大学子,为同学们编写一个可以随时随地查自己成绩.课表和自己想上课程的时间,地址等信息.最重要的一项功能是建立一个属于同学的专业知识讨论圈还有一个老 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
